// pages/detail/detail.js
import dgyPoster from '../../dist/js/dgyPoster-config.js';
const app = getApp();
Page({
  data: {
    coverHide: true,
    isShare: false, //分享、海报
    canSave: false, // 是否可以保存海报
    isAuth: false, // 判断scope.writePhotosAlbum是否已授权
    openSetting: '', // 保存图片授权
    dgyConfig: dgyPoster.duoguyu, // 默认海报样式
    title:'[代码片段]使用Canvas创建自定义阅读卡片/海报和分享',
    webName: '多骨鱼',
    sloganText: '相信有一天，理想主义终将所向披靡.',
    canvasQRCode: '../../dist/images/qrcode.jpg', // 小程序码
    posterBox: '../../dist/images/poster-bg.jpg', // 海报底图
    thumb: '../../dist/images/thumb.jpg', // 封面图
    canvasImg: '' // 待绘制的海报图
  },

  // 生成阅读卡片
  createPosterCard(e) {
    this.setData({
      coverHide: true
    })
    wx.showToast({ title: '卡片生成中', icon: 'loading' });
    this.creatImg(); // 生成海报
  },

  // 关闭海报弹窗
  cancelPosterCover() {
    this.setData({
      canSave: false
    })
  },


  // 处理 新版本 分享、海报等
  switchShare(e) {
    let isShare = !this.data.isShare;
    this.setData({ isShare });
  },

  /**
   * 创建海报
   */
  //保存图片
  creatImg() {
    let that = this;
    let dgyConfig = this.data.dgyConfig; // 海报样式 基础配置信息
    let title = this.data.title; // 标题
    let webName = this.data.webName; // 小程序名称
    let canvasQRCode = this.data.canvasQRCode; // 二维码
    let sloganText = this.data.sloganText; // slogan
    let posterBox = this.data.posterBox; // 上方底图
    let thumb = this.data.thumb; //封面图
    let ctx = wx.createCanvasContext('canvasImg'); // 创建海报

    // 背景图，canvas底图
    ctx.save();
    ctx.setFillStyle('white');
    ctx.fillRect(dgyConfig.map.x, dgyConfig.map.y, dgyConfig.map.w, dgyConfig.map.h);

    // 上方背景图
    ctx.save();
    ctx.beginPath();
    ctx.drawImage(posterBox, dgyConfig.posterBox.x, dgyConfig.posterBox.y, dgyConfig.posterBox.w, dgyConfig.posterBox.h);
    ctx.restore();

    // 封面图
    ctx.save();
    ctx.beginPath();
    ctx.drawImage(thumb, dgyConfig.poster.x, dgyConfig.poster.y, dgyConfig.poster.w, dgyConfig.poster.h);
    ctx.restore();

    // 主标题 - 文章标题
    ctx.save();
    ctx.setTextAlign(dgyConfig.title.t);
    ctx.setFontSize(dgyConfig.title.f);
    ctx.setFillStyle(dgyConfig.title.c);
    // 处理 文字多行折行
    let ostrtxt = '';
    let olinenum = 0;
    let oarrtxt = [];
    for (let i = 0; i < title.length; i++) {
      ostrtxt = ostrtxt + title[i];
      let ometricsw = ctx.measureText(ostrtxt);
      if (ometricsw.width > 590) {
        olinenum++;
        oarrtxt = oarrtxt.concat([ostrtxt]);
        ostrtxt = '';
      }
    }
    oarrtxt = oarrtxt.concat([ostrtxt]);
    if (olinenum == 0) {
      ctx.fillText(oarrtxt[0], dgyConfig.title.x, dgyConfig.title.y, 590);
    } else {
      for (let j = 0; j < oarrtxt.length; j++) {
        ctx.fillText(oarrtxt[j], dgyConfig.title.x, (dgyConfig.title.y + j * 60), 590);
      }
    }
    ctx.restore();

    // 小程序名称 webName
    ctx.save();
    ctx.setTextAlign(dgyConfig.webName.t);
    ctx.setFontSize(dgyConfig.webName.f);
    ctx.setFillStyle(dgyConfig.webName.c);
    ctx.fillText(webName, dgyConfig.webName.x, dgyConfig.webName.y);
    ctx.restore();


    // 底部文字信息 - 长按识别小程序码，查看文章详情
    ctx.save();
    ctx.setTextAlign(dgyConfig.detail.t);
    ctx.setFontSize(dgyConfig.detail.f);
    ctx.setFillStyle(dgyConfig.detail.c);
    ctx.fillText('长按识别小程序码，查看详情', dgyConfig.detail.x, dgyConfig.detail.y);
    ctx.restore();

    //绘制二维码
    ctx.save();
    ctx.beginPath();
    ctx.drawImage(canvasQRCode, dgyConfig.qrCode.x, dgyConfig.qrCode.y, dgyConfig.qrCode.w, dgyConfig.qrCode.h);
    ctx.restore();

    // slogan
    ctx.save();
    ctx.setTextAlign(dgyConfig.slogan.t);
    ctx.setFontSize(dgyConfig.slogan.f);
    ctx.setFillStyle(dgyConfig.slogan.c);
    ctx.fillText(sloganText, dgyConfig.slogan.x, dgyConfig.slogan.y);
    ctx.restore();

    ctx.draw(false, function () {
      setTimeout(function () {
        wx.canvasToTempFilePath({
          x: 0,
          y: 0,
          width: dgyConfig.map.w,
          height: dgyConfig.map.h,
          destWidth: dgyConfig.map.w,
          destHeight: dgyConfig.map.h,
          canvasId: 'canvasImg',
          success(res) {
            wx.hideLoading();
            that.setData({
              canvasImg: res.tempFilePath,
              canSave: true,
            });
          },
          fail(res) {
            wx.showToast({ icon: 'none', title: '生成图片失败，请稍后重试', duration: 2000 })
          }
        })
      }, 100)
    })
  },

  // 保存图片
  savePoster() {
    const that = this,
      canvasImg = that.data.canvasImg;
    wx.saveImageToPhotosAlbum({
      filePath: canvasImg,
      success(res) {
        wx.showToast({ title: '保存成功！', icon: 'success', duration: 3000 })
        that.setData({
          openSetting: '',
          canSave: false
        })
      },
      fail(res) {
        wx.showToast({ icon: 'none', title: '保存图片失败，请稍后重试', duration: 2000 })
      }
    })
  },


  // 保存操作
  saveImg() {
    let that = this;
    wx.getSetting({
      success: function (res) {
        if (!res.authSetting['scope.writePhotosAlbum']) {
          wx.authorize({
            scope: 'scope.writePhotosAlbum',
            success: function () {
              that.savePoster();
              that.setData({ isAuth: false });
            },
            fail: function (err) {
              wx.showToast({ title: '请开启相册授权，否则无法将图片保存在相册中！', icon: 'none' });
              that.setData({ isAuth: true })
            }
          })
        } else {
          that.savePoster();
        }
      }
    });
  },

  // 获取用户授权-保存相册
  handleSetting(e) {
    let isAuth = false;
    if (!e.detail.authSetting['scope.writePhotosAlbum']) {
      isAuth = true;
      wx.showModal({ title: '警告', content: '不授权无法保存', showCancel: false })
    }
    this.setData({ isAuth })
  },

  // 授权取消
  cancelCover() {
    this.setData({
      coverHide: true
    })
  },


  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function (res) {
    if (res.from === 'button') {
      // 来自页面内转发按钮
      console.log(res.target)
    }
    return {
      title: this.data.title,
      path: `/pages/index/index`,
      imageUrl: this.data.thumb
    }
  }
})